//+------------------------------------------------------------------+
//|                                      Heiken Ashi Ma Smoothed.mq4 |
//+------------------------------------------------------------------+
//|                                                      mod by Raff |
//|                                               2009 mod by mladen |
//|                                              tools made it lines |
//|                  2014 mod by AnyWay (One of mladen's apprentice) |
//+------------------------------------------------------------------+
#property copyright "Copyright ?2008,Forex-TSD.com"
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    MaPeriod        = 6;
extern int    MaMethod        = MODE_SMMA;
extern int    MaPeriod2       = 2;
extern int    MaMethod2       = MODE_LWMA;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   Interpolate     = true;

//
//
//
//
//

double Buffer0[];
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double Buffer5[];
double Buffer6[];
double trend[];

string indicatorFileName;
bool   calculateHA;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//|------------------------------------------------------------------|
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0, Buffer0); 
   SetIndexBuffer(1, Buffer1);
   SetIndexBuffer(2, Buffer2);
   SetIndexBuffer(3, Buffer3);
   SetIndexBuffer(4, Buffer4);
   SetIndexBuffer(5, Buffer5);
   SetIndexBuffer(6, Buffer6);
   SetIndexBuffer(7, trend);
   
   //
   //
   //
   //
   //
      
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      calculateHA       = (TimeFrame=="calculateHA");
      timeFrame = stringToTimeFrame(TimeFrame);

return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { Buffer0[0] = limit+1; return(0); }
         if (calculateHA) { calculateHA(limit);   return(0); }
          
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      if (trend[limit]==-1) CleanPoint(limit,Buffer1,Buffer2);         
      for(int pos=limit; pos >= 0; pos--)
      {
         double haOpen  = iCustom(NULL,timeFrame,indicatorFileName,"calculateHA",MaPeriod,MaMethod,MaPeriod2,MaMethod2,3,pos);
         double haClose = iCustom(NULL,timeFrame,indicatorFileName,"calculateHA",MaPeriod,MaMethod,MaPeriod2,MaMethod2,4,pos);
         
         Buffer0[pos] = (haOpen + haClose)/2;
         Buffer1[pos] = EMPTY_VALUE;
         Buffer2[pos] = EMPTY_VALUE;
         trend[pos] = trend[pos+1];
             if (haOpen < haClose) trend[pos] =  1;
             if (haOpen > haClose) trend[pos] = -1;
             if (trend[pos] == -1) PlotPoint(pos,Buffer1,Buffer2,Buffer0);  
       }   
       manageAlerts();
       return(0);
    }
    
    //
    //
    //
    //
    //
   
    limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    if (trend[limit]==-1) CleanPoint(limit,Buffer1,Buffer2);
    for(pos = limit; pos >= 0; pos--)
    {
     int y = iBarShift(NULL,timeFrame,Time[pos]);
        trend[pos]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaMethod,MaPeriod2,MaMethod2,0,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,7,y);
        Buffer0[pos] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaMethod,MaPeriod2,MaMethod2,1,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,0,y);
        Buffer1[pos] = EMPTY_VALUE;
        Buffer2[pos] = EMPTY_VALUE;
        
         //
         //
         //
         //
         //
      
         if (Interpolate<1 || y==iBarShift(NULL,timeFrame,Time[pos-1])) continue;

         //
         //
         //
         //
         //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; pos+n < Bars && Time[pos+n] >= time; n++) continue;	
               for(int k = 1; k < n; k++)
                  Buffer0[pos+k] = Buffer0[pos] + (Buffer0[pos+n] - Buffer0[pos])*k/n;
    }
    for(pos = limit; pos >= 0; pos--)if(trend[pos] == -1)PlotPoint(pos,Buffer1,Buffer2,Buffer0); 
 return(0);
 }
 
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void calculateHA(int limit)
{
   for (int i=limit; i>=0; i--)
   {
      double maOpen  = iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_OPEN ,i);
      double maClose = iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_CLOSE,i);
      double maLow   = iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_LOW  ,i);
      double maHigh  = iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_HIGH ,i);
      double haOpen  = (Buffer5[i+1]+Buffer6[i+1])/2.0;
      double haClose = (maOpen+maHigh+maLow+maClose)/4;
 
          Buffer5[i] = haOpen;
          Buffer6[i] = haClose;
   }
   for(i=limit; i>=0; i--)
   {
      Buffer3[i] = iMAOnArray(Buffer5,0,MaPeriod2,0,MaMethod2,i);
      Buffer4[i] = iMAOnArray(Buffer6,0,MaPeriod2,0,MaMethod2,i);
   }      
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" - Heiken Ashi Smoothed Lines  "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Heiken Ashi Smoothed Lines "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}



